(function() {
  var Abstract, Advance, Default, Normal, Simple, coreMethods, customAbility, defineProperty, extend, getPropertyManagerClass, getkeys, isFunction, isNumber, isObject, isString;

  customAbility = require('custom-ability');

  defineProperty = require('util-ex/lib/defineProperty');

  isFunction = require('util-ex/lib/is/type/function');

  isObject = require('util-ex/lib/is/type/object');

  isString = require('util-ex/lib/is/type/string');

  isNumber = require('util-ex/lib/is/type/number');

  extend = require('util-ex/lib/_extend');

  Default = require('./');

  Simple = require('./simple');

  Normal = require('./normal');

  Advance = require('./advance');

  Abstract = require('./abstract');

  getkeys = Object.keys;

  getPropertyManagerClass = function(aClass, aOptions) {
    var PropertyManager, gManager, gOptPos, nonExported1stChar;
    if (isString(aOptions)) {
      aOptions = {
        name: aOptions
      };
    } else if (isNumber(aOptions)) {
      aOptions = {
        optionsPosition: aOptions
      };
    } else if (!aOptions) {
      aOptions = {};
    }
    gOptPos = aOptions.optionsPosition || 0;
    gManager = String(aOptions.name);
    nonExported1stChar = aOptions.nonExported1stChar;
    return PropertyManager = (function() {
      var orgInitialize;

      function PropertyManager() {
        this.initialize.call(this, arguments[gOptPos]);
      }

      switch (gManager.toLowerCase()) {
        case 'simple':
          extend(PropertyManager.prototype, Simple.prototype);
          break;
        case 'advance':
          extend(PropertyManager, Advance);
          extend(PropertyManager.prototype, Advance.prototype);
          break;
        case 'abstract':
          extend(PropertyManager, Abstract);
          extend(PropertyManager.prototype, Abstract.prototype);
          break;
        case 'normal':
          extend(PropertyManager, Normal);
          extend(PropertyManager.prototype, Normal.prototype);
          break;
        default:
          extend(PropertyManager, Default);
          extend(PropertyManager.prototype, Default.prototype);
      }

      if (isString(nonExported1stChar) && nonExported1stChar.length === 1) {
        PropertyManager.prototype.nonExported1stChar = nonExported1stChar;
      }

      orgInitialize = PropertyManager.prototype.initialize;

      defineProperty(PropertyManager.prototype, '$initialize', function() {
        var inherited, options, that;
        options = arguments[gOptPos];
        if (options == null) {
          options = {};
        }
        that = this.self || this;
        inherited = this["super"];
        if (inherited) {
          if (inherited.apply(that, arguments) === 'ok') {
            return;
          }
        }
        return orgInitialize.call(that, options);
      });

      defineProperty(PropertyManager.prototype, '$assign', function() {
        var that;
        that = this.self || this;
        if (this["super"]) {
          return this["super"].apply(that, arguments);
        }
        return this.__assign.apply(that, arguments);
      });

      return PropertyManager;

    })();
  };

  coreMethods = ['__assign', 'assignPropertyTo', 'getProperties', 'mergeTo', 'defineProperties', 'nonExported1stChar'];

  module.exports = customAbility(getPropertyManagerClass, coreMethods, true);

  module.exports["default"] = module.exports;

}).call(this);

//# sourceMappingURL=ability.js.map
