(function() {
  var AdvancePropertyManager, Properties, PropertyManager, assignValue, defineProperties, defineProperty, extend, getPrototypeOf, getkeys, isFunction, isObject, isString;

  defineProperty = require('util-ex/lib/defineProperty');

  isFunction = require('util-ex/lib/is/type/function');

  isObject = require('util-ex/lib/is/type/object');

  isString = require('util-ex/lib/is/type/string');

  extend = require('util-ex/lib/_extend');

  getPrototypeOf = require('inherits-ex/lib/getPrototypeOf');

  Properties = require('./properties');

  PropertyManager = require('./abstract');

  assignValue = require('./assign-value');

  defineProperties = require('./properties/define-properties');

  getkeys = Object.keys;

  module.exports = AdvancePropertyManager = (function() {
    AdvancePropertyManager.getProperties = function() {
      var k, ref, result, v;
      result = {};
      if (this.prototype.$attributes) {
        ref = this.prototype.$attributes;
        for (k in ref) {
          v = ref[k];
          result[k] = v;
        }
      }
      return result;
    };

    AdvancePropertyManager.prototype.$attributes = null;

    AdvancePropertyManager.prototype.SMART_ASSIGN = Properties.SMART_ASSIGN;

    defineProperty(AdvancePropertyManager, '$attributes', void 0, {
      get: function() {
        return getPrototypeOf(this).$attributes;
      }
    });

    function AdvancePropertyManager() {
      this.initialize.apply(this, arguments);
    }

    extend(AdvancePropertyManager.prototype, PropertyManager.prototype);

    AdvancePropertyManager.prototype.getProperties = function() {
      return this.$attributes;
    };

    AdvancePropertyManager.defineProperties = defineProperties;

    AdvancePropertyManager.prototype.defineProperties = function(aProperties, recreate) {
      var vAttrs;
      if (recreate == null) {
        recreate = false;
      }
      vAttrs = defineProperties(this, aProperties, recreate);
      vAttrs.initializeTo(this);
      return this;
    };

    AdvancePropertyManager.prototype.assignPropertyTo = function(dest, src, name, value, attrs, options) {
      if (!attrs) {
        attrs = this.getProperties();
      }
      attrs.assignPropertyTo(dest, src, name, value, options);
    };

    return AdvancePropertyManager;

  })();

  module.exports["default"] = module.exports;

}).call(this);

//# sourceMappingURL=advance.js.map
