(function() {
  var ArrayPropertyManager, PropertyManager, assignValue, defineProperty, isFunction, mapItemType,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    slice = [].slice;

  defineProperty = require('util-ex/lib/defineProperty');

  isFunction = require('util-ex/lib/is/type/function');

  assignValue = require('./assign-value');

  PropertyManager = require('./ability');

  mapItemType = function(items, type) {
    if (!Array.isArray(items)) {
      items = [items];
    }
    return items.map((function(_this) {
      return function(item) {
        return assignValue(item, type);
      };
    })(this));
  };

  module.exports = ArrayPropertyManager = (function(superClass) {
    extend(ArrayPropertyManager, superClass);

    ArrayPropertyManager.arrayOf = function(type) {
      return function(value) {
        return new ArrayPropertyManager(value, type);
      };
    };

    function ArrayPropertyManager(value, type) {
      ArrayPropertyManager.__super__.constructor.call(this);
      defineProperty(this, '$type', type);
      if (value) {
        this.push(value);
      }
    }

    ArrayPropertyManager.prototype.push = function() {
      var arr, value;
      value = arguments[0], arr = 2 <= arguments.length ? slice.call(arguments, 1) : [];
      value = mapItemType(value, this.$type);
      if (Array.isArray(arr)) {
        value.push.apply(value, mapItemType(arr, this.$type));
      }
      return ArrayPropertyManager.__super__.push.apply(this, value);
    };

    ArrayPropertyManager.prototype.unshift = function() {
      var arr, value;
      value = arguments[0], arr = 2 <= arguments.length ? slice.call(arguments, 1) : [];
      value = mapItemType(value, this.$type);
      if (Array.isArray(arr)) {
        value.push.apply(value, mapItemType(arr, this.$type));
      }
      return ArrayPropertyManager.__super__.unshift.apply(this, value);
    };

    ArrayPropertyManager.prototype.toJSON = function() {
      return this.toObject();
    };

    ArrayPropertyManager.prototype.toObject = function(options) {
      return this.map((function(_this) {
        return function(item) {
          if (item != null) {
            if (isFunction(item.toObject)) {
              item = item.toObject(options);
            } else if (isFunction(item.toJSON)) {
              item = item.toJSON();
            }
          }
          return item;
        };
      })(this));
    };

    ArrayPropertyManager.prototype.valueOf = function() {
      return this.toObject();
    };

    return ArrayPropertyManager;

  })(Array);

  module.exports["default"] = module.exports;

}).call(this);

//# sourceMappingURL=array.js.map
