(function() {
  var assignValue;

  assignValue = function(value, type) {
    var err, error, msg;
    if (typeof type === 'function' && !(value instanceof type)) {
      try {
        value = type(value);
      } catch (error) {
        err = error;
        msg = err.message;
        if (!(msg.endsWith('\'new\'') || msg.endsWith(' a function'))) {
          throw err;
        }
        value = new type(value);
      }
    }
    return value;
  };

  module.exports = assignValue;

  module.exports["default"] = assignValue;

}).call(this);

//# sourceMappingURL=assign-value.js.map
