(function() {
  var Properties, getPrototypeOf, isFunction, isObject;

  isFunction = require('util-ex/lib/is/type/function');

  isObject = require('util-ex/lib/is/type/object');

  getPrototypeOf = require('inherits-ex/lib/getPrototypeOf');

  Properties = require('./');

  module.exports = function(aTarget, aProperties, recreate) {
    var nonExported1stChar, vAttrs, vHasOwnProperty, vIsProperties, vPrototype;
    if (isFunction(aTarget)) {
      vPrototype = aTarget.prototype;
      nonExported1stChar = vPrototype.nonExported1stChar;
    } else if (isObject(aTarget)) {
      vPrototype = getPrototypeOf(aTarget);
      nonExported1stChar = aTarget.nonExported1stChar;
    } else {
      throw new TypeError('the target should be a ctor or object!');
    }
    vAttrs = vPrototype.$attributes;
    vHasOwnProperty = vPrototype.hasOwnProperty('$attributes');
    vIsProperties = vAttrs instanceof Properties;
    if (nonExported1stChar == null) {
      nonExported1stChar = Properties.prototype.nonExported1stChar;
    }
    if (recreate !== true && !vHasOwnProperty && vIsProperties) {
      vPrototype.$attributes = vAttrs = vAttrs["extends"](aProperties, nonExported1stChar);
    } else if (recreate || !vIsProperties) {
      vPrototype.$attributes = vAttrs = Properties(aProperties, nonExported1stChar);
    } else {
      if (vAttrs.nonExported1stChar !== nonExported1stChar) {
        vAttrs.nonExported1stChar = nonExported1stChar;
      }
      vAttrs.merge(aProperties);
    }
    return vAttrs;
  };

}).call(this);

//# sourceMappingURL=define-properties.js.map
