(function() {
  var Properties, assignValue, cloneObject, deepEqual, defineProperty, getObjectKeys, getOwnPropertyNames, getPropertyDescriptor, isArray, isBoolean, isFunction, isObject, isString, setPrototypeOf,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  setPrototypeOf = require('inherits-ex/lib/setPrototypeOf');

  isString = require('util-ex/lib/is/type/string');

  isArray = require('util-ex/lib/is/type/array');

  isBoolean = require('util-ex/lib/is/type/boolean');

  isFunction = require('util-ex/lib/is/type/function');

  isObject = require('util-ex/lib/is/type/object');

  defineProperty = require('util-ex/lib/defineProperty');

  cloneObject = require('util-ex/lib/clone-object');

  deepEqual = require('deep-equal');

  assignValue = require('../assign-value');

  getObjectKeys = Object.keys;

  getOwnPropertyNames = Object.getOwnPropertyNames;

  getPropertyDescriptor = Object.getOwnPropertyDescriptor;

  module.exports = Properties = (function() {
    var defaultNonExported1stChar, privated;

    privated = defineProperty.bind(null, Properties.prototype);

    Properties.SMART_ASSIGN = '';

    privated('nonExported1stChar', defaultNonExported1stChar = '$');

    privated('extends', function(attrs, nonExported1stChar) {
      var result;
      if (nonExported1stChar == null) {
        nonExported1stChar = this.nonExported1stChar;
      }
      result = Properties(attrs, nonExported1stChar);
      setPrototypeOf(result, this);
      result.updateNames();
      return result;
    });

    privated('merge', function(attrs) {
      return this.mergeTo(attrs, this);
    });

    privated('mergeTo', function(attrs, dest) {
      var attr, i, k, keys, len, name;
      if (!attrs) {
        return dest;
      }
      if (!dest) {
        dest = {};
      }
      if (attrs instanceof Properties) {
        keys = (function() {
          var results;
          results = [];
          for (k in attrs.names) {
            results.push(k);
          }
          return results;
        })();
      } else {
        keys = getObjectKeys(attrs);
      }
      for (i = 0, len = keys.length; i < len; i++) {
        name = keys[i];
        attr = attrs[name];
        this.mergePropertyTo(dest, name, attr);
      }
      if (dest.updateNames) {
        dest.updateNames();
      }
      return dest;
    });

    privated('mergePropertyTo', function(dest, name, attr) {
      var k, v, vAttr, vEnumerable, vWritable;
      if (!(!isArray(attr) && isObject(attr))) {
        attr = {
          value: attr
        };
      }
      if ((attr.enumerable == null) && attr.assigned === false && attr.exported === false) {
        attr.enumerable = false;
      } else {
        attr.enumerable = attr.enumerable !== false;
      }
      vEnumerable = attr.enumerable !== false;
      vWritable = attr.writable !== false || isFunction(attr.set);
      if (attr.assigned == null) {
        attr.assigned = vEnumerable && vWritable;
      }
      if (attr.exported == null) {
        attr.exported = vEnumerable && name[0] !== this.nonExported1stChar && vWritable;
      }
      vAttr = dest[name];
      if (vAttr === void 0) {
        dest[name] = attr;
      } else {
        for (k in attr) {
          v = attr[k];
          vAttr[k] = v;
        }
      }
    });

    privated('_initialize', function(aOptions) {
      return this.merge(aOptions);
    });

    privated('initialize', function(aOptions) {
      this._initialize(aOptions);
    });

    function Properties(aOptions, nonExported1stChar) {
      if (!(this instanceof Properties)) {
        return new Properties(aOptions, nonExported1stChar);
      }
      defineProperty(this, 'names', {});
      defineProperty(this, 'ixNames', {});
      if (!(isString(nonExported1stChar) && nonExported1stChar.length === 1)) {
        nonExported1stChar = defaultNonExported1stChar;
      }
      defineProperty(this, 'nonExported1stChar', nonExported1stChar);
      this.initialize(aOptions);
    }

    privated('updateNames', function() {
      var i, k, len, n, v, vAlias;
      this.names = {};
      this.ixNames = {};
      for (k in this) {
        v = this[k];
        if (!isObject(v) || (v.enumerable == null)) {
          continue;
        }
        this.names[k] = v.name || k;
        this.ixNames[v.name || k] = k;
        vAlias = v.alias;
        if (vAlias) {
          if (isArray(vAlias)) {
            for (i = 0, len = vAlias.length; i < len; i++) {
              n = vAlias[i];
              this.ixNames[n] = k;
            }
          } else if (isString(vAlias)) {
            this.ixNames[vAlias] = k;
          }
        }
      }
    });

    privated('initializeTo', function(dest, src, aOptions) {
      var err, error, k, nonExported1stChar, overwrite, ref, skipNull, skipUndefined, v, vAttr, vAttrName, value;
      if (src == null) {
        src = {};
      }
      if (aOptions == null) {
        aOptions = {};
      }
      skipNull = aOptions.skipNull, skipUndefined = aOptions.skipUndefined, overwrite = aOptions.overwrite;
      nonExported1stChar = this.nonExported1stChar;
      ref = this.names;
      for (k in ref) {
        v = ref[k];
        if (k === 'name') {
          continue;
        }
        if (!overwrite && dest[k] !== void 0) {
          continue;
        }
        vAttr = this[k];
        value = src[k];
        if (value === void 0) {
          value = vAttr.value;
        }
        if (skipNull && value === null) {
          continue;
        }
        if (skipUndefined && value === void 0) {
          continue;
        }
        if (isString(vAttr.assigned) && !vAttr.get && !vAttr.set) {
          vAttr = cloneObject(vAttr);
          vAttrName = vAttr.assigned || nonExported1stChar + k;
          defineProperty(dest, vAttrName, value);
          (function(name, assign) {
            vAttr.get = function() {
              return this[name];
            };
            if (vAttr.writable || isFunction(assign)) {
              if (isFunction(assign)) {
                return vAttr.set = function(v) {
                  this[name] = assign(v, this, this, name);
                };
              } else {
                return vAttr.set = function(v) {
                  return this[name] = v;
                };
              }
            }
          })(vAttrName, vAttr.assign);
        }
        if (!vAttr.get && !vAttr.set && vAttr.clone !== false && isObject(value)) {
          try {
            value = cloneObject(value);
          } catch (error) {
            err = error;
            err.message = 'the attribute "' + k + '" can not be cloned, set descriptor "clone" to false.\n' + err.message;
            throw err;
          }
        }
        value = assignValue(value, vAttr.type);
        defineProperty(dest, k, value, vAttr);
        if (dest[k] !== value) {
          dest[k] = value;
        }
      }
    });

    privated('getRealAttrName', function(name) {
      if (!this.hasOwnProperty(name)) {
        name = this.ixNames[name];
      }
      return name;
    });

    privated('validatePropertyValue', function(name, value, attr, raiseError) {
      var i, k, len, ref, result, v, vType;
      if (isBoolean(attr)) {
        raiseError = attr;
        attr = null;
      }
      if (!attr) {
        attr = this[name];
      }
      result = attr != null;
      if (raiseError == null) {
        raiseError = true;
      }
      if (!result) {
        throw new TypeError('no such property name:' + name);
      }
      if (this.Type && (value != null) && (attr.type != null) && value !== attr.value) {
        vType = this.Type(attr.type);
        if (vType) {
          result = vType.isValid(value);
          if (!result && raiseError) {
            k = "assign attribute '" + name + "' error";
            if (vType.errors.length) {
              k += ": the value '" + value + "'";
              ref = vType.errors;
              for (i = 0, len = ref.length; i < len; i++) {
                v = ref[i];
                k += "\n " + v.name + ": " + v.message;
              }
              if (dest.errors) {
                dest.errors = vType.errors;
              }
            }
            throw new TypeError(k);
          }
        }
      }
      return result;
    });

    privated('assignPropertyTo', function(dest, src, name, value, options) {
      var isExported, skipDefault, skipExists, vAttr, vAttrName, vCanAssign, vIsAssigned;
      if (options) {
        skipDefault = options.skipDefault, isExported = options.isExported, skipExists = options.skipExists;
      }
      name = this.getRealAttrName(name);
      if (name) {
        vAttr = this[name];
        if (skipExists && dest[name] !== void 0) {
          return;
        }
        vIsAssigned = vAttr.assigned || isString(vAttr.assigned);
        if (!((vIsAssigned && !isExported) || (vAttr.exported && isExported))) {
          return;
        }
        if (skipDefault && (vAttr.exported !== true || vAttr.writable !== false) && deepEqual(vAttr.value, value)) {
          return;
        }
        vCanAssign = (!isExported && vIsAssigned) || value !== void 0;
        if (name === 'name' && vCanAssign && value !== dest.name) {
          dest.name = value;
          return;
        }
        if (!isExported) {
          this.validatePropertyValue(name, value, vAttr);
        }
        if (isFunction(vAttr.assign)) {
          value = vAttr.assign(value, dest, src, name, options);
        }
        if (isExported) {
          name = vAttr.name || name;
        }
        if (value === void 0 && vAttr.value !== void 0) {
          value = vAttr.value;
        }
        if (vCanAssign) {
          if (isString(vAttr.assigned)) {
            vAttrName = vAttr.assigned || this.nonExported1stChar + name;
          }
          if (!(vAttrName && !vAttr.get && !vAttr.set && isFunction(vAttr.assign) && dest.hasOwnProperty(vAttrName))) {
            vAttrName = name;
          }
          if (isExported) {
            if (value != null) {
              if (isFunction(value.toObject)) {
                value = value.toObject(options);
              } else if (isFunction(value.toJSON)) {
                value = value.toJSON();
              }
            }
            dest[vAttrName] = value;
          } else {
            dest[vAttrName] = assignValue(value, vAttr.type);
          }
        }
      }
    });

    privated('assignTo', function(dest, src, aOptions) {
      var exclude, k, overwrite, skipNull, skipReadOnly, skipUndefined, v, vAttr, vNames, vValue;
      if (aOptions == null) {
        aOptions = {};
      }
      exclude = aOptions.exclude, skipReadOnly = aOptions.skipReadOnly, skipNull = aOptions.skipNull, skipUndefined = aOptions.skipUndefined, overwrite = aOptions.overwrite;
      if (isString(exclude)) {
        exclude = [exclude];
      } else if (!isArray(exclude)) {
        exclude = [];
      }
      if (dest == null) {
        dest = {};
      }
      vNames = this.names;
      for (k in vNames) {
        v = vNames[k];
        if ((indexOf.call(exclude, v) >= 0) || (indexOf.call(exclude, k) >= 0)) {
          continue;
        }
        if (skipReadOnly && v.writable === false || (v.get && !v.set)) {
          continue;
        }
        vAttr = this[k];
        vValue = src[v] || src[k];
        if (skipNull && vValue === null) {
          continue;
        }
        if (skipUndefined && vValue === void 0) {
          continue;
        }
        if (overwrite || dest[k] === void 0) {
          this.assignPropertyTo(dest, src, k, vValue, aOptions);
        }
      }
      return dest;
    });

    privated('isDefaultObject', function(aObject) {
      var attr, k, ref, result, v, value;
      result = true;
      ref = this.names;
      for (k in ref) {
        v = ref[k];
        attr = this[k];
        if (k === 'name' || attr.writable === false || attr.enumerable === false) {
          continue;
        }
        value = this.getValue(aObject, k);
        if (!(value === void 0 || value === attr.value)) {
          result = false;
          break;
        }
      }
      return result;
    });

    privated('getValue', function(aOptions, aName) {
      var attr, i, len, ref, result;
      result = aOptions[aName];
      if (result == null) {
        attr = this[aName];
        if (attr != null) {
          result = aOptions[attr.name];
          if ((result == null) && attr.alias) {
            if (isString(attr.alias)) {
              result = aOptions[attr.alias];
            } else if (isArray(attr.alias)) {
              ref = attr.alias;
              for (i = 0, len = ref.length; i < len; i++) {
                aName = ref[i];
                result = aOptions[aName];
                if (result != null) {
                  break;
                }
              }
            }
          }
        }
      }
      return result;
    });

    return Properties;

  })();

  module.exports["default"] = module.exports;

}).call(this);

//# sourceMappingURL=index.js.map
