(function() {
  var PropertyManager, SimplePropertyManager, cloneObject, deepEqual, defineProperty, extend, getAllOwnKeys, getOwnPropertyDescriptor, getkeys, isArray, isFunction, isObject, isString;

  defineProperty = require('util-ex/lib/defineProperty');

  isFunction = require('util-ex/lib/is/type/function');

  isObject = require('util-ex/lib/is/type/object');

  isString = require('util-ex/lib/is/type/string');

  isArray = require('util-ex/lib/is/type/array');

  extend = require('util-ex/lib/_extend');

  cloneObject = require('util-ex/lib/clone-object');

  deepEqual = require('deep-equal');

  PropertyManager = require('./abstract');

  getkeys = Object.keys;

  getAllOwnKeys = Object.getOwnPropertyNames;

  getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

  module.exports = SimplePropertyManager = (function() {
    function SimplePropertyManager() {
      this.initialize.apply(this, arguments);
    }

    extend(SimplePropertyManager.prototype, PropertyManager.prototype);

    SimplePropertyManager.prototype.getProperties = function() {
      var i, k, len, ref, result;
      result = {};
      ref = getAllOwnKeys(this);
      for (i = 0, len = ref.length; i < len; i++) {
        k = ref[i];
        if (k === 'defaultOptions') {
          continue;
        }
        result[k] = getOwnPropertyDescriptor(this, k);
      }
      return result;
    };

    SimplePropertyManager.prototype.defineProperties = function(aProperties) {
      var k, v, vIsReadonly, value;
      for (k in aProperties) {
        v = aProperties[k];
        if (!(!isArray(v) && isObject(v))) {
          v = {
            value: v
          };
        }
        v.enumerable = v.enumerable !== false;
        vIsReadonly = v.writable === false || (v.get && !v.set);
        if (vIsReadonly && v.exported !== true) {
          v.enumerable = false;
        }
        value = v.value;
        if (!v.get && !v.set && isObject(value)) {
          value = cloneObject(value);
        }
        defineProperty(this, k, value, v);
      }
    };

    SimplePropertyManager.prototype.assignPropertyTo = function(dest, src, name, value, attrs, options) {
      var isExported, vAttr, vCanAssign;
      if (options) {
        isExported = options.isExported;
      }
      if (!attrs) {
        attrs = this.getProperties();
      }
      vAttr = attrs[name];
      if (vAttr && vAttr.enumerable) {
        vCanAssign = (!isExported && (vAttr.writable || vAttr.set)) || (isExported && value !== void 0 && name[0] !== this.nonExported1stChar);
        if (vCanAssign) {
          if (isExported && (value != null)) {
            if (isFunction(value.toObject)) {
              value = value.toObject(options);
            } else if (isFunction(value.toJSON)) {
              value = value.toJSON();
            }
          }
          dest[name] = value;
        }
      }
    };

    return SimplePropertyManager;

  })();

  module.exports["default"] = module.exports;

}).call(this);

//# sourceMappingURL=simple.js.map
